/* This example is part of RTBApi
 * Copyright (C) 1998 Ruben <ryu@mundivia.es>                           
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtbapi.h"

#define PI 3.14159265358979323846

/*
Compilar: 
   gcc -Wall -combine parser.c rtbapi.c bahamut.c -o bahamut.robot && cp bahamut.robot /usr/lib/realtimebattle/Robots/ && chmod 777 /usr/lib/realtimebattle/Robots/bahamut.robot

*/

void initialize(int i)
{
    RobotOption(SEND_ROTATION_REACHED,1);
    if (i==1) /* Need to send name and colour */
    {
        Name("Bahamut");
        Colour(0x930606,0x0090ff);
    }
}

#define AMOUNT 0.4

double game_options[32]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

void game_option(game_option_type type, double value)
{
  game_options[type]=value;
}
/*void energy (double vitae)//co co deeeeeeeeeeeeee

{

if vitae <30.0 BuscarGalleto;


}
*/

void radar(double distance, object_type observed,double angle)
{
  static int rotating=0;
  static int direction=+1;
  static int not_visible=0;
  static int searching=0;
  static int accelerating=10;
  static float searching_pos=0.0;
  static double accel=0.0;

   Accelerate(game_options[ROBOT_MAX_ACCELERATION]/1.5);
  if (observed==IS_ROBOT) 
  {
     Shoot(100/distance);
     rotating=0;
     not_visible=0;
     searching=0;
     accel=0;
     searching_pos=0;
     accelerating=1;
     Brake(0.5);
     Accelerate(game_options[ROBOT_MAX_ACCELERATION]/1.5);
  }else{  
     if (rotating==0) { searching=1; searching_pos=0.0; 
       Accelerate(game_options[ROBOT_MAX_ACCELERATION]/1.5);}
     rotating=5;
     if (searching==0 || searching==3) accel+=0.1;

     if (rotating && searching_pos>=300)
     {
       searching_pos=0.0;
       direction=-direction;fprintf(stderr,"<%i>\n",direction);
       Brake(0.0);
       Accelerate(game_options[ROBOT_MAX_ACCELERATION]/2);
       Rotate(ROTATE_ROBOT,+game_options[ROBOT_MAX_ROTATE]);
}
 if (observed==IS_COOKIE){

     Brake(0.0);
     Accelerate(game_options[ROBOT_MAX_ACCELERATION]);
     RotateTo (ROTATE_ROBOT, 0, 0);
}

 if (observed==IS_MINE){
if (distance<6.0){
          Shoot(1);
          Brake(1.0);
}
else{
          Rotate(ROTATE_ROBOT,+game_options[ROBOT_MAX_ROTATE]/2);
          Brake(1.0);}
}


       if (distance<2.0 && observed==IS_WALL)
       {
          Rotate(ROTATE_ROBOT,game_options[ROBOT_MAX_ROTATE]);
          Brake(1.0);

       }
       else
         {
         Brake(0.0);
	      Accelerate(game_options[ROBOT_MAX_ACCELERATION]/2);
         }
       accelerating=5;


     if (searching>0 && searching<3) 
     {
       Brake(1.0);
       not_visible++;
       if (searching==1)
         if (not_visible>(1/AMOUNT)*10) {not_visible=0;direction=-direction;searching++;}
       if (searching==2)
         if (not_visible>(1/AMOUNT)*20) {not_visible=0;direction=-direction;searching++;}
     }
  }
  if (rotating) Rotate(ROTATE_ROBOT, direction*(AMOUNT+accel));
  if (rotating)
    searching_pos+=direction*(AMOUNT+accel);
}

void exit_robot()
{
    Print("Megafulgoooooor!!!");
    exit(1);
}
        
int main()
{
/* Initializing Callbacks */
Initialize=initialize;
Radar=radar;
ExitRobot=exit_robot;
GameOption=game_option;

/* Calling parser */
Scanner();

/* Ouch, parser exited, there was an error */
return 1;
}
